(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
    typeof define === 'function' && define.amd ? define(factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.usingTryCatch = factory());
}(this, (function () { 'use strict';

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    const usingTryCatch = (promise) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            if (Array.isArray(promise)) {
                return { data: yield Promise.all(promise), error: null };
            }
            return { data: yield promise, error: null };
        }
        catch (error) {
            return { data: null, error };
        }
    });

    return usingTryCatch;

})));
//# sourceMappingURL=index.js.map
